/*
 * PM - 2017
 * lab0.c
 */

#include <avr/io.h>
#include <util/delay.h>

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

#define MORSE_LUNG		150
#define MORSE_SCURT		50
#define MORSE_PAUZA		50

#define NUM_NOTE		8 
 
#define DIGIT1			PD0
#define DIGIT2			PD1
#define DIGIT3			PD2
#define DIGIT4			PD3

#define A 				PC0
#define B 				PC1
#define C 				PC2
#define D 				PC3
#define E 				PC4
#define F 				PC5
#define G 				PC6
#define DP 				PC7

int frecventa_nota[NUM_NOTE] = {
	262, 294, 330, 349, 392, 440, 494, 523
};

int _7seg[4] = {0, 0, 0, 0};

/* Genereaza sunetul pentru tipul de ton folosit: lung (150ms) sau scurt (50ms). */
void speaker_morse(int tip_morse) {
	int i;

	/* Alternam starea pinului PD4 la fiecare milisecunda. */
	for (i = 0; i < tip_morse; ++i) {
		PIND = (1 << PD4);

		_delay_ms(1);
	}
}

/* Genereaza o nota folosind speaker-ul. */
void speaker_reda(int nota) {
	int perioada_nota = 1000000l / frecventa_nota[nota];
	int i;

	/*
	 * Nu putem folosi variable ca argument pentru functia
	 * _delay_us(), asa ca folosim acest "workaround".
	 */
	PORTD |= (1 << PD4);
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);

	PORTD &= ~(1 << PD4);
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);
}


//digit = 0..9; pos = 0..3
void reset_7seg() {
	
	PORTC |= (1 << A);
	PORTC |= (1 << B);
	PORTC |= (1 << C);
	PORTC |= (1 << D);
	PORTC |= (1 << E);
	PORTC |= (1 << F);
	PORTC |= (1 << G);
	PORTC |= (1 << DP);
	
	PORTD &= ~(1 << DIGIT1);
	PORTD &= ~(1 << DIGIT2);
	PORTD &= ~(1 << DIGIT3);
	PORTD &= ~(1 << DIGIT4);
}

void write_digit(int digit, int pos) {
	
	switch(pos) {
		case 0:
			PORTD |= (1 << DIGIT1);
			break;
		case 1:
			PORTD |= (1 << DIGIT2);
			break;
		case 2:
			PORTD |= (1 << DIGIT3);
			break;
		case 3:
			PORTD |= (1 << DIGIT4);
			break;
		default:
			break;
	}
	
	switch(digit) {
		case 0:
			PORTC &= ~(1 << D);
			PORTC &= ~(1 << E);
			PORTC &= ~(1 << F);
			PORTC &= ~(1 << A);
			PORTC &= ~(1 << B);
			PORTC &= ~(1 << G);
			break;
		case 1:
			PORTC &= ~(1 << F);
			PORTC &= ~(1 << G);
			break;
		case 2:
			PORTC &= ~(1 << D);
			PORTC &= ~(1 << F);
			PORTC &= ~(1 << A);
			PORTC &= ~(1 << B);
			PORTC &= ~(1 << DP);
			break;
		case 3:
			PORTC &= ~(1 << D);
			PORTC &= ~(1 << F);
			PORTC &= ~(1 << B);
			PORTC &= ~(1 << DP);
			PORTC &= ~(1 << G);
			break;
		case 4:
			PORTC &= ~(1 << E);
			PORTC &= ~(1 << F);
			PORTC &= ~(1 << G);
			PORTC &= ~(1 << DP);
			break;
		case 5:
			PORTC &= ~(1 << D);
			PORTC &= ~(1 << E);
			PORTC &= ~(1 << B);
			PORTC &= ~(1 << G);
			PORTC &= ~(1 << DP);
			break;
		case 6:
			PORTC &= ~(1 << D);
			PORTC &= ~(1 << E);
			PORTC &= ~(1 << A);
			PORTC &= ~(1 << B);
			PORTC &= ~(1 << G);
			PORTC &= ~(1 << DP);
			break;
		case 7:
			PORTC &= ~(1 << D);
			PORTC &= ~(1 << F);
			PORTC &= ~(1 << G);
			break;
		case 8:
			PORTC &= ~(1 << D);
			PORTC &= ~(1 << E);
			PORTC &= ~(1 << F);
			PORTC &= ~(1 << A);
			PORTC &= ~(1 << B);
			PORTC &= ~(1 << G);
			PORTC &= ~(1 << DP);
			break;
		case 9:
			PORTC &= ~(1 << D);
			PORTC &= ~(1 << E);
			PORTC &= ~(1 << F);
			PORTC &= ~(1 << B);
			PORTC &= ~(1 << G);
			PORTC &= ~(1 << DP);
			break;
		default:
			break;
	}
}

void refresh_display(){
	
	reset_7seg();
	write_digit(_7seg[0], 0);
	reset_7seg();
	write_digit(_7seg[1], 1);
	reset_7seg();
	write_digit(_7seg[2], 2);
	reset_7seg();
	write_digit(_7seg[3], 3);
	reset_7seg();
}

void set_score(int score){
	
	int trunk_scor = score%10000;
	_7seg[3] = trunk_scor/1000;
	_7seg[2] = (trunk_scor%1000)/100;
	_7seg[1] = (trunk_scor%100)/10;
	_7seg[0] = trunk_scor%10;
}

int main(void) {
	DDRB |= (1 << A);
	DDRB |= (1 << B);
	DDRB |= (1 << C);
	DDRB |= (1 << D);
	DDRB |= (1 << E);
	DDRB |= (1 << F);
	DDRB |= (1 << G);
	DDRB |= (1 << DP);
	
	DDRA |= (1 << DIGIT1);
	DDRA |= (1 << DIGIT2);
	DDRA |= (1 << DIGIT3);
	DDRA |= (1 << DIGIT4);
	
	int cont = 0;
	int flag = 0;
	int i;
	
	while (1) {
		
		if (cont == 10) {
			
			/* Setez pinul PD4 ca iesire. */
			DDRD |= (1 << PD4);

		/* Opresc speaker-ul. */
		PORTD &= ~(1 << PD4);
		
		int contor = 0;
		while (1) {
			//if ((PINB & (1 << C)) == 0)
			if (contor == 0) {
				speaker_morse(MORSE_SCURT);
				contor++;
			}
			else {
			//else if ((PIND & (1 << PD6)) == 0)
				speaker_morse(MORSE_LUNG);
				contor++;
			}
			PORTD &= ~(1 << PD4);
			_delay_ms(MORSE_PAUZA);
			//_delay_ms(20);
			for(i = 0; i < 500; i++) {
				refresh_display();
			}
			set_score(cont);
			}
			
		}
	}

	return 0;
}

